(******************* Parameters *******************)

M$Parameters = {
  xiG == {TeXName -> "\\xi_G"},
  xiA == {TeXName -> "\\xi_A"},
  xiW == {TeXName -> "\\xi_W"},
  xiZ == {TeXName -> "\\xi_Z"},

(***** Romao & Silva eta's (cf. 1209.6213) *****)
  etae == {TeXName -> "\\eta_e"},
  eta1 == {TeXName -> "\\eta'"},
  eta2 == {TeXName -> "\\eta"},
  eta3 == {TeXName -> "\\eta_s"},
  etat == {TeXName -> "\\eta_{\\theta}"},
  etaZ == {TeXName -> "\\eta_Z"},
(***********************************************)

  gw == {TeXName -> "g_w"},
  g1 == {TeXName -> "g_1"},
  gs == {TeXName -> "g_s"},

  DWZ == {TeXName -> "\\Gamma_Z", NumValue -> 2.4952},
  DWW == {TeXName -> "\\Gamma_W", NumValue -> 2.085},

  me == {TeXName -> "m_e", NumValue -> 0.0005109989461},
  mm == {TeXName -> "m_m", NumValue -> 0.1056583745},
  mtt == {TeXName -> "m_{\\tau}", NumValue -> 1.77686},
  mu == {TeXName -> "m_u", NumValue -> 0.0022},
  mc == {TeXName -> "m_c", NumValue -> 1.275},
  mt == {TeXName -> "m_t", NumValue -> 173.1},
  md == {TeXName -> "m_d", NumValue -> 0.0047},
  ms == {TeXName -> "m_s", NumValue -> 0.095},
  mb == {TeXName -> "m_b", NumValue -> 4.18},
  MW == {TeXName  -> "m_W",
         Renormalization -> {MW -> MW + dMW2/(2 MW)},
         NumValue -> 80.379},
  MZ == {TeXName  -> "m_Z",
         Renormalization -> {MZ -> MZ + dMZ2/(2 MZ)},
         NumValue -> 91.1876},
  MH == {TeXName  -> "m_h",
         Renormalization -> {MH -> MH + dMH2/(2 MH)},
         NumValue -> 125.18},

  vv == {TeXName -> "v"},
  tad == {Renormalization -> {tad -> dtad}},
  ee == {TeXName -> "e",
         Renormalization -> {ee -> ee + dee ee},
         NumValue -> 0.302822},
  sw == {TeXName -> "s_w",
         Renormalization -> {sw -> sw + dsw},
         NumValue -> 0.4808580293600181},
  cw == {TeXName -> "c_w",
         Renormalization -> {cw -> cw + dcw},
         NumValue -> 0.876798469204868}, 
  muH == {TeXName -> "\\mu"},
  lbd == {TeXName -> "\\lambda"},
  Ml == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Ml -> Ml + dMl}},
  Muq == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Muq -> Muq + dMuq}},
  Mdq == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Mdq -> Mdq + dMdq}},
  CKM == {Indices -> {Index[Generation], Index[Generation]},
      		TeXName -> "V",
      		NumValue -> {0.97420,0.2243,0.00394,0.218,0.997,0.0422,0.0081,0.0394,1.019},
      		Unitary -> True,
          Renormalization -> {CKM -> CKM + dCKM},
      		ComplexParameter -> True},

(********* Counterterms *********)
  dZAA == {Counterterm -> True, TeXName -> "\\delta Z_{AA}"},
  dZAZ == {Counterterm -> True, TeXName -> "\\delta Z_{AZ}"},
  dZZA == {Counterterm -> True, TeXName -> "\\delta Z_{ZA}"},
  dZZZ == {Counterterm -> True, TeXName -> "\\delta Z_{ZZ}"},
  dZW == {Counterterm -> True, TeXName -> "\\delta Z_{W}"},
  dZH == {Counterterm -> True, TeXName -> "\\delta Z_{H}"},
  dZdqL == {Counterterm -> True,
            TeXName -> "\\delta Z^{dq,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZdqR == {Counterterm -> True,
            TeXName -> "\\delta Z^{dq,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZuqL == {Counterterm -> True,
            TeXName -> "\\delta Z^{uq,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZuqR == {Counterterm -> True,
            TeXName -> "\\delta Z^{uq,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZlL == {Counterterm -> True,
           TeXName -> "\\delta Z^{l,L}",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True},
  dZlR == {Counterterm -> True,
           TeXName -> "\\delta Z^{l,R}",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True},
  dZvlL == {Counterterm -> True,
            TeXName -> "\\delta Z^{vl,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZvlR == {Counterterm -> True,
            TeXName -> "\\delta Z^{vl,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
    
  dMdq == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]}},
  dMuq == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]}},
  dMl == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]}},
  dmuq == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True},
  dmdq == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True},
  dml == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True},

  dme == {Counterterm -> True, TeXName -> "\\delta m_e"},
  dmm == {Counterterm -> True, TeXName -> "\\delta m_m"},
  dmtt == {Counterterm -> True, TeXName -> "\\delta m_{\\tau}"},
  dmu == {Counterterm -> True, TeXName -> "\\delta m_u"},
  dmc == {Counterterm -> True, TeXName -> "\\delta m_c"},
  dmt == {Counterterm -> True, TeXName -> "\\delta m_t"},
  dmd == {Counterterm -> True, TeXName -> "\\delta m_d"},
  dms == {Counterterm -> True, TeXName -> "\\delta m_s"},
  dmb == {Counterterm -> True, TeXName -> "\\delta m_b"},

  dee == {Counterterm -> True, TeXName -> "\\delta e"},

  dMW2 == {Counterterm -> True, TeXName -> "\\delta m_W^2"},
  dMZ2 == {Counterterm -> True, TeXName -> "\\delta m_Z^2"},
  dMH2 == {Counterterm -> True, TeXName -> "\\delta m_h^2"},

  dcw == {Counterterm -> True, TeXName -> "\\delta c_w"},
  dsw == {Counterterm -> True, TeXName -> "\\delta s_w"},
  dtad == {Counterterm -> True, TeXName -> "\\delta t"},
  dCKM == {Counterterm -> True,
           TeXName -> "\\delta V",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True}
}